<?php
// *******************************************************************************************
// ************************************   Edit Document   ************************************ 
function editDoc(){
	global $url_agentdb, $agent_name, $action, $docid, $url_mailview, $url_maildb, $field_coll, $current_field, $main, $fieldnames, $field_counter, $msg_not_logged_in;
	$url_doc = $url_agentdb . "/$agent_name?OpenAgent";
	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startElementOpenDoc", "endElementOpenDoc");
	xml_set_character_data_handler($xml_parser, "textDataOpenDoc");
	$req="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" . 
"<request>\n" . 
"<action>open</action>\n" . 
"<unid>$docid</unid>\n" . 
"<maildb>" . $_SESSION["MailDB"] . "</maildb>\n" . 
"<fields>\n" . 
"<field>From</field>\n" . 
"<field>Subject</field>\n" . 
"<field>Body</field>\n" . 
"<field>SendTo</field>\n" . 
"<field>PostedDate</field>\n" . 
"</fields>\n" . 
"</request>";
	$data = postWebPage($url_doc, $_SESSION["DominoCookie"], $req); 
	if (mustLogin($data)) {  //is cookie expired and user must login again?
		print "<b><font color=\"red\">$msg_not_logged_in</font></b>";
		loginForm();
		return;
	} 
	if (!xml_parse($xml_parser, $data, true)) {
		die(sprintf("XML error: %s at line %d",	xml_error_string(xml_get_error_code($xml_parser)), xml_get_current_line_number($xml_parser)));
	}
	xml_parser_free($xml_parser);
	$foldertitle="Edit";
	print ("<center><span class=\"foldertitle\">" . $foldertitle . "</span></center><br>"); 
	if ($field_counter>0) {

	include("editmemo_form.php");

	} else {
		print ("<b>No fields found in opened mail document.</b>");
	}
}


// *******************************************************************************************
// ************************************   Open Document   ************************************ 
function openDoc(){
	global $url_agentdb, $agent_name, $action, $docid, $url_mailview, $url_maildb, $field_coll, $current_field, $main, $fieldnames, $field_counter, $msg_not_logged_in;
	$url_doc = $url_agentdb . "/$agent_name?OpenAgent";
	$fieldmapper=array();
	$fieldmapper["SendTo"]="Send to";
	$fieldmapper["From"]="From";
	$fieldmapper["PostedDate"]="Date";
	$fieldmapper["Subject"]="Subject";
	$fieldmapper["Body"]="Message";
	
	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startElementOpenDoc", "endElementOpenDoc");
	xml_set_character_data_handler($xml_parser, "textDataOpenDoc");
	$req="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" . 
"<request>\n" . 
"<action>open</action>\n" . 
"<unid>$docid</unid>\n" . 
"<maildb>" . $_SESSION["MailDB"] . "</maildb>\n" . 
"<fields>\n" . 
"<field>From</field>\n" . 
"<field>Subject</field>\n" . 
"<field>Body</field>\n" . 
"<field>SendTo</field>\n" . 
"<field>PostedDate</field>\n" . 
"</fields>\n" . 
"</request>";
	$data = postWebPage($url_doc, $_SESSION["DominoCookie"], $req); 
	if (mustLogin($data)) {  //is cookie expired and user must login again?
		print "<b><font color=\"red\">$msg_not_logged_in</font></b>";
		loginForm();
		return;
	} 
	if (!xml_parse($xml_parser, $data, true)) {
		die(sprintf("XML error: %s at line %d",	xml_error_string(xml_get_error_code($xml_parser)), xml_get_current_line_number($xml_parser)));
	}
	xml_parser_free($xml_parser);
	$foldertitle="Mail document";
	print ("<center><span class=\"foldertitle\">" . $foldertitle . "</span></center><br>"); 
	if ($field_counter>0) {
		print "<table border=\"1\" width=\"580\" class=\"table1\">\n";
		for($i = 0;$i < count($fieldnames);$i++) {
			print "<tr>";
			print ("<td width=80 class=\"tableleftheader1\">" . (isset($fieldmapper[$fieldnames[$i]]) ? $fieldmapper[$fieldnames[$i]]: $fieldnames[$i]) . "</td>");
			print ("<td>" . str_replace("\n","<br>", $field_coll[$fieldnames[$i]]) . "</td>");
			print "</tr>\n";
		}
	print "</table>\n";
	print "<br><form name=\"form1\" method=\"post\" action=\"" . $_SERVER['PHP_SELF'] . "?docid=$docid\">\n";
	print "<input name=\"action\" type=\"submit\" id=\"Edit\" value=\"Edit\">\n";
	print "</form>\n";
	} else {
		print ("<b>No fields found in opened mail document.</b>");
	}
}


// ***************************************************************************************
// ************************************   Open View   ************************************ 
function readView(){
	global $view_design, $url_mailview, $doc_coll, $unids, $doc_counter, $folder, $foldertitle, $this_script, $msg_not_logged_in;
	  //Database might allow anonymous access, so we do not always need a cookie
		if (!isset($_SESSION["DominoCookie"])){  
		print "<b><font color=\"red\">$msg_not_logged_in</font></b>";
		loginForm();
		return;
	}
	
	$success=readViewDesign($url_mailview);  // Get view's column names and column numbers
	if ($success==false) return;  
	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startElement", "endElement");
	xml_set_character_data_handler($xml_parser, "textData");
	$data = getWebPage($url_mailview ."?ReadViewEntries&Count=100", $_SESSION["DominoCookie"]);  

	
	if (!xml_parse($xml_parser, $data, true)) {
		die(sprintf("XML error: %s at line %d",
			xml_error_string(xml_get_error_code($xml_parser)),
			xml_get_current_line_number($xml_parser))
		);
	}
	xml_parser_free($xml_parser);

	print ("<center><span class=\"foldertitle\">" . $foldertitle . "</span></center><br>"); 
	if ($doc_counter>0) {
		print "<table border=\"0\" STYLE=\"table-layout:fixed\" WIDTH=\"580\" class=\"table1\">\n";
		if($folder=="Inbox"){
			print "<tr class=\"tableheader1\"><td style=\"width:100px\">From</td><td style=\"width:50px\">Size</td><td style=\"width:130px\">Date</td><td style=\"width:300px\">Subject</td></tr>";
		}else{
			print "<tr class=\"tableheader1\"><td style=\"width:150px\">To</td><td style=\"width:130px\">Date</td><td width=\"300\">Subject</td></tr>";
		}
		for($i = 0;$i < count($unids);$i++) {
			print "<tr>";
								
			if($folder=="Inbox"){
				print ("<td><a href=\"$this_script?action=opendoc&docid=". $unids[$i] . "\">" . (getViewColumnByTitle($i, "WHO")==""? "-":getViewColumnByTitle($i, "WHO")) . "</a></td>"); //From
				print ("<td>" . getViewColumnByTitle($i, "SIZE") . "</td>"); //Size
				print ("<td>" . convertDominoTime(getViewColumnByTitle($i, "DATE")) . "</td>"); //Date
				print ("<td>" . getViewColumnByTitle($i, "SUBJECT") . "</td>"); //Subject
			}elseif($folder=="Sent"){
				print ("<td><a href=\"$this_script?action=opendoc&docid=". $unids[$i] . "\">" . (getViewColumnByTitle($i, "WHO")==""? "-":getViewColumnByTitle($i, "WHO")) . "</a></td>"); //To
				print ("<td>" . convertDominoTime(getViewColumnByTitle($i, "DATE")) . "</td>"); //Date
				print ("<td>" . getViewColumnByTitle($i, "SUBJECT") . "</td>"); //Subject
			}else{  //Drafts
				print ("<td><a href=\"$this_script?action=opendoc&docid=". $unids[$i] . "\">" . (getViewColumnByTitle($i, "WHO")==""? "-":getViewColumnByTitle($i, "WHO")) . "</a></td>"); //To
				print ("<td>" . convertDominoTime(getViewColumnByTitle($i, "DATE")) . "</td>"); //Date
				print ("<td>" . getViewColumnByTitle($i, "SUBJECT") . "</td>"); //Subject
			}
			
			
			print "</tr>\n";
		}
		print "</table>\n";
	} else {
		print ("<b>No emails found.</b>");
	}
}

function getViewColumnByTitle($docnr, $fname){
global $view_design, $doc_coll, $unids, $folder;
return $doc_coll[$unids[$docnr]]["ENTRYDATA"][$view_design[$folder][$fname]];
}

function getViewColumnByNr($docnr, $colnr){
global $doc_coll, $unids, $folder;
return $doc_coll[$unids[$docnr]]["ENTRYDATA"][$colnr];
}


// *******************************************************************************************
// ************************************   Send Document   ************************************ 
function sendDoc(){
	global $url_agentdb, $agent_name, $url_maildb, $docid, $msg_not_logged_in;
	
	if($docid==NULL || $docid=="")$docid="none";  //set dummy UNID on new docs
	$req="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" . 
"<request>\n" . 
"<action>mail</action>\n" . 
"<unid>$docid</unid>\n" .
"<maildb>" . $_SESSION["MailDB"] . "</maildb>\n" . 
"<fields>\n" . 
"<field name=\"SendTo\">" . ($_POST['sendto']!="" ?  $_POST['sendto'] : "-") . "</field>\n" . 
"<field name=\"Subject\">" . ($_POST['subject']!="" ?  $_POST['subject'] : "-") . "</field>\n" . 
"<field name=\"Body\">" . ($_POST['body']!="" ?  $_POST['body'] : "-") . "</field>\n" . 
"</fields>\n" . 
"</request>";
	$url_doc = $url_agentdb . "/$agent_name?OpenAgent";
	$data = postWebPage($url_doc, $_SESSION["DominoCookie"], $req); 
	if (mustLogin($data)) {  //is cookie expired and user must login again?
		print "<b><font color=\"red\">$msg_not_logged_in</font></b>";
		loginForm();
		return;
	} 
	print "Submitted successfully";
}

// *******************************************************************************************
// ************************************   Save as Draft   ************************************
function saveDraft(){
	global $url_agentdb, $agent_name, $url_maildb, $msg_not_logged_in;
	$req="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" . 
"<request>\n" . 
"<action>draft</action>\n" . 
"<maildb>" . $_SESSION["MailDB"] . "</maildb>\n" . 
"<fields>\n" . 
"<field name=\"SendTo\">" . ($_POST['sendto']!="" ?  $_POST['sendto'] : "-") . "</field>\n" . 
"<field name=\"Subject\">" . ($_POST['subject']!="" ?  $_POST['subject'] : "-") . "</field>\n" . 
"<field name=\"Body\">" . ($_POST['body']!="" ?  $_POST['body'] : "-") . "</field>\n" . 
"</fields>\n" . 
"</request>";
	$url_doc = $url_agentdb . "/$agent_name?OpenAgent";
	$data = postWebPage($url_doc, $_SESSION["DominoCookie"], $req); 
	if (mustLogin($data)) {  //is cookie expired and user must login again?
		print "<b><font color=\"red\">$msg_not_logged_in</font></b>";
		loginForm();
		return;
	}
	print "Submitted successfully";
}


// **********************************************************************************************
// ************************************   Compose new mail   ************************************
function composeDoc(){
	global $url_agentdb, $url_maildb, $agent_name, $this_script, $msg_not_logged_in;
	$req="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" . 
"<request>\n" . 
"<action>ping</action>\n" . 
"<maildb>" . $_SESSION["MailDB"] . "</maildb>\n" . 
"</request>";
	$url_doc = $url_agentdb . "/$agent_name?OpenAgent";
	$data = postWebPage($url_doc, $_SESSION["DominoCookie"], $req); //send dummy request to see if we are logged in
	if (mustLogin($data)) {  //is cookie expired and user must login again?
		print "<b><font color=\"red\">$msg_not_logged_in</font></b>";
	loginForm();
	return;
	}
	$foldertitle="New mail";
	print ("<center><span class=\"foldertitle\">" . $foldertitle . "</span></center><br>"); 
	include("memo_form.php");
}
// *******************************************************************************************
// ************************************   Delete Document   ************************************
function deleteDoc(){
	global $url_agentdb, $agent_name, $url_maildb, $docid, $msg_not_logged_in;
	$req="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" . 
"<request>\n" . 
"<action>delete</action>\n" . 
"<unid>$docid</unid>\n" . 
"<maildb>" . $_SESSION["MailDB"] . "</maildb>\n" . 
"</request>";
	$url_doc = $url_agentdb . "/$agent_name?OpenAgent";
	$data = postWebPage($url_doc, $_SESSION["DominoCookie"], $req); 
	if (mustLogin($data)) {  //is cookie expired and user must login again?
		print "<b><font color=\"red\">$msg_not_logged_in</font></b>";
		loginForm();
		return;
	} 
	print "Submitted successfully";
}

// *******************************************************************************************
// ************************************   Save Document   ************************************
function saveDoc(){
	global $url_agentdb, $agent_name, $url_maildb, $docid, $msg_not_logged_in;
	$req="<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" . 
"<request>\n" . 
"<action>save</action>\n" . 
"<unid>$docid</unid>\n" . 
"<maildb>" . $_SESSION["MailDB"] . "</maildb>\n" . 
"<fields>\n" . 
"<field name=\"SendTo\">" . ($_POST['sendto']!="" ?  $_POST['sendto'] : "-") . "</field>\n" . 
"<field name=\"Subject\">" . ($_POST['subject']!="" ?  $_POST['subject'] : "-") . "</field>\n" . 
"<field name=\"Body\">" . ($_POST['body']!="" ?  $_POST['body'] : "-") . "</field>\n" . 
"</fields>\n" . 
"</request>";
	$url_doc = $url_agentdb . "/$agent_name?OpenAgent";
	$data = postWebPage($url_doc, $_SESSION["DominoCookie"], $req); 
	if (mustLogin($data)) {  //is cookie expired and user must login again?
		print "<b><font color=\"red\">$msg_not_logged_in</font></b>";
		loginForm();
		return;
	} 
	print "Submitted successfully";
}


// ***************************************************************************************
// ************************************   Read View Design   ************************************ 
function readViewDesign(){
	global $url_mailview, $doc_coll, $unids, $doc_counter, $folder, $foldertitle, $this_script, $msg_not_logged_in;
		
	$xml_parser = xml_parser_create();
	xml_set_element_handler($xml_parser, "startElementViewDesign", "endElementViewDesign");
	
	$data = getWebPage($url_mailview . "?ReadDesign", $_SESSION["DominoCookie"]);  
	if (mustLogin($data)) {  //is cookie expired and user must login again?
		print "<b><font color=\"red\">$msg_not_logged_in</font></b>";
		loginForm();
		return false;
	}
	if (!xml_parse($xml_parser, $data, true)) {
		die(sprintf("XML error: %s at line %d",
			xml_error_string(xml_get_error_code($xml_parser)),
			xml_get_current_line_number($xml_parser))
		);
	}
	xml_parser_free($xml_parser);
	return true;
}

// Convert date to easy-readable format (2006-03-28 16:05 instead of 20060328T160530,02+02)
function convertDominoTime($domtime){
//expected format in Domino xml view: 20060328T160530,02+02
	$timepos= $pos = strpos($domtime, "T");  //letter T separates time from date
	$resultdate= substr( $domtime, 0, 5) . "-" . substr( $domtime, 5, 2) . "-" . substr( $domtime, 7, 2);
	$resulttime= substr( $domtime, $timepos+1, 2) . ":" . substr( $domtime, $timepos+1+2, 2) ;
	return "$resultdate $resulttime";
}

?>
 