<?php
session_start();
?>
<html>
<head>
<title>PHP GUI for Domino mail</title>
<meta http-equiv="Expires" content="0"> 
<meta http-equiv="Cache-Control" content="must-revalidate"> 
<meta http-equiv="Cache-Control" content="no-cache">
<link rel="stylesheet" type="text/css" href="style.css" />
</head>
<body>
<table width="750" height="280" border="0" cellpadding="5" class="table2">
  <tr align="left" valign="top" bgcolor="#FFFFCC">
    <td height="29" colspan="2"><div align="center" style="font: bold 14 px Verdana">Simple PHP GUI for Domino mail</div></td>
  </tr>
  <tr align="left" valign="top">
    <td width="150" height="245" background="dominoes.jpg" bgcolor="#EAEAEA" class="nav">
	<a href="<?php print $_SERVER['PHP_SELF'];?>?action=view&folder=Inbox">Inbox</a><br>
	<br>
      <a href="<?php print $_SERVER['PHP_SELF']?>?action=view&folder=Drafts">Draft</a><br><br>
      <a href="<?php print $_SERVER['PHP_SELF']?>?action=view&folder=Sent">Sent</a><br><br>
      <br><br>
    <a href="<?php print $_SERVER['PHP_SELF']?>?folder=New+Memo&action=compose">New mail</a><br>    <br></td>
    <td width="600" nowrap>
<?php
include("xmlfunctions.php");
include("urlfunctions.php");
include("docfunctions.php");

$url_login = "http://mydominoserver7.com/names.nsf";	// URL path to obtain session cookie. Can be any database which allows user to open it.
$url_agentdb = "http://mydominoserver7.com/mail/jdoe.nsf";	//URL to the database containing LotusScript agent
$agent_name="ProcessDocWebAction";		// Name of our XML-processing agent in the mail database
$url_maildb = "http://mydominoserver7.com/" . $_SESSION["MailDB"];

$namemapper = array();					// Array for holding view names
$namemapper["Inbox"]="(\$Inbox)";		// Inbox is alias for ($Inbox) folder in the mail database
$namemapper["Sent"]="(\$Sent)";			// Sent is alias for ($Sent) folder in the mail database
$namemapper["Draft"]="(\$Drafts)";		// Draft is alias for ($Drafts) folder in the mail database
$namemapper["Drafts"]="(\$Drafts)";		// Drafts is alias for ($Drafts) folder in the mail database

$doc_coll = array();		// Array for storing values parsed from XML
$field_coll = array();		// Array for storing field names parsed from XML
$unids = array();			// Array for storing Universal IDs parsed from XML
$fieldnames = array();		// Names of all fields we receieved back from XML agent
$view_design= array();
$current_doc = "";			// Current XML document being processed by XML parser
$current_field="";			// Current field name being processed by XML parser
$main = "";					// Current XML entity being processed by parser  (VIEWENTRY, ENTRYDATA)
$doc_counter = 0;			// Counter of documents processed by parser
$field_counter=0;			// Counter of fields in current document
$current_column="";			// Name of current field(column) from XML view  (1, 2, 3)
$this_script=$_SERVER['PHP_SELF']; // Path to this PHP script
$domino_cookie="";			// Session cookie received from Domino server after logging in
$action=(isset($_POST["action"])? $_POST["action"]:$_GET["action"]);			//Name of action  (view or compose)
$docid=(isset($_POST["docid"])? $_POST["docid"]:$_GET["docid"]);				//Universal ID of document being processed by PHP
$folder=(isset($_POST["folder"])? $_POST["folder"]:$_GET["folder"]);				//Name of view/folder to show
$foldertitle="$folder";		//Title of the folder section on the page
$msg_not_logged_in="You are not logged in";

$url_mailview = $url_maildb . "/" . $namemapper[$folder]; // URL path to view which we want to get as XML

//If no action specified in URL (&action=view), choose to show a folder
if($action==""){  
$action="view"; 
}

//If no folder specified in URL (&folder=inbox), show Inbox folder
if($folder==""){  
$folder="Inbox";
$foldertitle="$folder";		
$url_mailview = $url_maildb . "/" . $namemapper[$folder]; 
}

chooseAction($action);				//Decide what action should be taken


//show our login form with username and password fields
function loginForm(){ 
	include("login_form.php");		//Show login form with username and password fields
}

//Shows Domino session cookie user received after logging in.
//Not used programmatically. Can be called manually for debugging purposes using URL:  .php?action=cookie
function showcookie(){
	print $_SESSION["DominoCookie"];	//Value of Domino session cookie
}

function showMailPath(){
	print  $_SESSION["MailDB"];			//Path to user's mail database
}

//Login to Domino server using username and password and retrieve Domino session coookie.
//URL to login ($url_login) was specified in the global variables above.
//After successfull login that show Inbox fodler.
function doLogin($username, $password){
	global $namemapper, $url_maildb, $url_mailview, $url_login, $folder, $action;
	$myCoookie=getDominoCookie("$url_login","$username", "$password"); //Get session cookie
	if($myCoookie!=""){   //Session is not empty, so user is logged in. Works for my Domino, but might be adjusted for other versions
		$action=$_SESSION["PreLoginAction"];	//Set action to the action user initially supplied before he logged in
		$folder=$_SESSION["PreLoginFolder"];	//Set folder to the fodler user initially supplied before he logged in
		if($folder=="" || $folder==NULL)$folder="Inbox";
		if($action=="" || $action==NULL)$action="view";
		$url_mailview = $url_maildb . "/" . $namemapper[$folder]; 
		chooseAction($action);
	}else{
		print "<b><font color=\"red\">Could not login</font></b>";
		loginForm();
	}
}
function chooseAction($myaction){
switch($myaction){  //Decide what to do depending on the action parameter specified in URL
	case("newlogin"):loginForm();break;			//Show NEW login form even if we are logged in (login_form.php)
	case("Login"): doLogin(str_replace(" ", "+", $_POST["username"]), str_replace(" ", "+", $_POST["password"]));break;  //Show login form (login_form.php)
	case("view"):readView();break;				//Open specified view
	case("opendoc"):openDoc();break;			//Open document by it's Universal ID
	case("createdoc"):composeDoc();break;		//Create new mail document (memo_form.php)
	case("compose"):composeDoc();break;			//Create new mail document, alias to "compose" action
	case("savedraft"):saveDraft();break;		//Save new mail document as draft
	case("Save as draft"):saveDraft();break;	//Save new mail document as draft, alias to "savedraft"
	case("Draft"):saveDraft();break;			//Save new mail document as draft, alias to "savedraft"
	case("savedoc"):saveDoc();break;			//Save existing document by it's Universal ID
	case("Save"):saveDoc();break;				//Open document by it's Universal ID. Alias to "savedoc"
	case("senddoc"):sendDoc();break;			//Send new or existing document
	case("Send"):sendDoc();break;				//Send new or existing document. Alias to "senddoc"
	case("Edit"):editDoc();break;				//Edit document by it's Universal ID (editmemo_form.php)
	case("Delete"):deleteDoc();break;			//Delete document by it's Universal ID
	case("cookie"):showCookie();break;			//Print out value of Domino session cookie
	case("mailpath"):showMailPath();break;		//Print out value of path to user's mail dataabse
}
}

?>
      <br>
    <br></td>
  </tr>
</table>
<br>
  Demo username: John Doe
<br>password: john123 <br>
    <font color="#666666" size="1" face="Verdana, Arial, Helvetica, sans-serif"><br>
    <br>
    Created by: <a href="http://www.dominokonsult.se" target="_blank">Andrei Kouvchinnikov</a><br>
    This application is created for demo purposes only <br>
    and not tested in production environment. <br>
    The application is provided &quot;AS IS&quot; and without any <br>
    support or 
  warranty.<br>
  <br>
   <a href="help.php" target="_blank">Help</a></font>
</p>
</body>
</html>
